limit subset further if sample rate is <=48kHz: max blocksize is 4608 and max LPC...
[flac.git] / test / test_grabbag.sh
1 #!/bin/sh
2
3 #  FLAC - Free Lossless Audio Codec
4 #  Copyright (C) 2001,2002,2003,2004,2005,2006  Josh Coalson
5 #
6 #  This file is part the FLAC project.  FLAC is comprised of several
7 #  components distributed under difference licenses.  The codec libraries
8 #  are distributed under Xiph.Org's BSD-like license (see the file
9 #  COPYING.Xiph in this distribution).  All other programs, libraries, and
10 #  plugins are distributed under the GPL (see COPYING.GPL).  The documentation
11 #  is distributed under the Gnu FDL (see COPYING.FDL).  Each file in the
12 #  FLAC distribution contains at the top the terms under which it may be
13 #  distributed.
14 #
15 #  Since this particular file is relevant to all components of FLAC,
16 #  it may be distributed under the Xiph.Org license, which is the least
17 #  restrictive of those mentioned above.  See the file COPYING.Xiph in this
18 #  distribution.
19
20 die ()
21 {
22         echo $* 1>&2
23         exit 1
24 }
25
26 if [ x = x"$1" ] ; then 
27         BUILD=debug
28 else
29         BUILD="$1"
30 fi
31
32 LD_LIBRARY_PATH=../src/libFLAC/.libs:$LD_LIBRARY_PATH
33 LD_LIBRARY_PATH=../src/share/grabbag/.libs:$LD_LIBRARY_PATH
34 LD_LIBRARY_PATH=../src/share/replaygain_analysis/.libs:$LD_LIBRARY_PATH
35 LD_LIBRARY_PATH=../obj/$BUILD/lib:$LD_LIBRARY_PATH
36 export LD_LIBRARY_PATH
37 PATH=../src/test_grabbag/cuesheet:$PATH
38 PATH=../obj/$BUILD/bin:$PATH
39
40 test_cuesheet -h 1>/dev/null 2>/dev/null || die "ERROR can't find test_cuesheet executable"
41
42 run_test_cuesheet ()
43 {
44         if [ x"$FLAC__TEST_WITH_VALGRIND" = xyes ] ; then
45                 valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --logfile-fd=4 test_cuesheet $* 4>>test_grabbag.valgrind.log
46         else
47                 test_cuesheet $*
48         fi
49 }
50
51 if [ `env | grep -ic '^comspec='` != 0 ] ; then
52         is_win=yes
53 else
54         is_win=no
55 fi
56
57 ########################################################################
58 #
59 # test_cuesheet
60 #
61 ########################################################################
62
63 log=cuesheet.log
64 bad_cuesheets=cuesheets/bad.*.cue
65 good_cuesheets=cuesheets/good.*.cue
66 good_leadout=`expr 80 \* 60 \* 44100`
67 bad_leadout=`expr $good_leadout + 1`
68
69 rm -f $log
70
71 #
72 # negative tests
73 #
74 for cuesheet in $bad_cuesheets ; do
75         echo "NEGATIVE $cuesheet" >> $log 2>&1
76         run_test_cuesheet $cuesheet $good_leadout cdda >> $log 2>&1
77         exit_code=$?
78         if [ "$exit_code" = 255 ] ; then
79                 die "Error: test script is broken"
80         fi
81         cuesheet_pass1=${cuesheet}.1
82         cuesheet_pass2=${cuesheet}.2
83         rm -f $cuesheet_pass1 $cuesheet_pass2
84 done
85
86 #
87 # positve tests
88 #
89 for cuesheet in $good_cuesheets ; do
90         echo "POSITIVE $cuesheet" >> $log 2>&1
91         run_test_cuesheet $cuesheet $good_leadout cdda >> $log 2>&1
92         exit_code=$?
93         if [ "$exit_code" = 255 ] ; then
94                 die "Error: test script is broken"
95         elif [ "$exit_code" != 0 ] ; then
96                 die "Error: good cuesheet is broken"
97         fi
98         cuesheet_pass1=${cuesheet}.1
99         cuesheet_pass2=${cuesheet}.2
100         diff $cuesheet_pass1 $cuesheet_pass2 >> $log 2>&1 || die "Error: pass1 and pass2 output differ"
101         rm -f $cuesheet_pass1 $cuesheet_pass2
102 done
103
104 if [ $is_win = yes ] ; then
105         diff -w cuesheet.ok $log > cuesheet.diff || die "Error: .log file does not match .ok file, see cuesheet.diff"
106 else
107         diff cuesheet.ok $log > cuesheet.diff || die "Error: .log file does not match .ok file, see cuesheet.diff"
108 fi
109
110 echo "PASSED (results are in $log)"